diff -Narup Mtd-orig/util/compr.c mtd/util/compr.c
--- Mtd-orig/util/compr.c	2005-11-08 02:02:20.000000000 +0100
+++ mtd/util/compr.c	2005-11-29 16:36:08.000000000 +0100
@@ -1,489 +1,545 @@
-/*
- * JFFS2 -- Journalling Flash File System, Version 2.
- *
- * Copyright (C) 2004 Ferenc Havasi <havasi@inf.u-szeged.hu>,
- *                    University of Szeged, Hungary
- *
- * For licensing information, see the file 'LICENCE' in this directory
- * in the jffs2 directory.
- *
- * $Id: compr.c,v 1.9 2005/11/07 11:15:09 gleixner Exp $
- *
- */
-
-#include "compr.h"
+#include <stdio.h>
 #include <string.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/ioctl.h>
+#include <sys/types.h>
+#include <asm/types.h>
+#include <stdint.h>
+#include <stddef.h>
 #include <stdlib.h>
-#include <linux/jffs2.h>
-
-extern int page_size;
-
-/* LIST IMPLEMENTATION (from linux/list.h) */
-
-#define LIST_HEAD_INIT(name) { &(name), &(name) }
-
-#define LIST_HEAD(name) \
-        struct list_head name = LIST_HEAD_INIT(name)
-
-static inline void __list_add(struct list_head *new,
-                              struct list_head *prev,
-                              struct list_head *next)
-{
-        next->prev = new;
-        new->next = next;
-        new->prev = prev;
-        prev->next = new;
-}
-
-static inline void list_add(struct list_head *new, struct list_head *head)
-{
-        __list_add(new, head, head->next);
-}
-
-static inline void list_add_tail(struct list_head *new, struct list_head *head)
-{
-        __list_add(new, head->prev, head);
-}
-
-static inline void __list_del(struct list_head *prev, struct list_head *next)
-{
-        next->prev = prev;
-        prev->next = next;
-}
-
-static inline void list_del(struct list_head *entry)
-{
-        __list_del(entry->prev, entry->next);
-        entry->next = (void *) 0;
-        entry->prev = (void *) 0;
-}
-
-#define list_entry(ptr, type, member) \
-        ((type *)((char *)(ptr)-(unsigned long)(&((type *)0)->member)))
-
-#define list_for_each_entry(pos, head, member)                          \
-        for (pos = list_entry((head)->next, typeof(*pos), member);      \
-             &pos->member != (head);                                    \
-             pos = list_entry(pos->member.next, typeof(*pos), member))
-
-
-/* Available compressors are on this list */
-static LIST_HEAD(jffs2_compressor_list);
-
-/* Actual compression mode */
-static int jffs2_compression_mode = JFFS2_COMPR_MODE_PRIORITY;
-
-void jffs2_set_compression_mode(int mode)
-{
-        jffs2_compression_mode = mode;
-}
-
-int jffs2_get_compression_mode(void)
-{
-        return jffs2_compression_mode;
-}
-
-/* Statistics for blocks stored without compression */
-static uint32_t none_stat_compr_blocks=0,none_stat_decompr_blocks=0,none_stat_compr_size=0;
-
-/* Compression test stuffs */
-
-static int jffs2_compression_check = 0;
-
-static unsigned char *jffs2_compression_check_buf = NULL;
-
-void jffs2_compression_check_set(int yesno)
-{
-        jffs2_compression_check = yesno;
-}
-
-int jffs2_compression_check_get(void)
-{
-        return jffs2_compression_check;
-}
-
-static int jffs2_error_cnt = 0;
-
-int jffs2_compression_check_errorcnt_get(void)
-{
-        return jffs2_error_cnt;
-}
-
-#define JFFS2_BUFFER_FILL 0x55
 
-/* Called before compression (if compression_check is setted) to prepare
-   the buffer for buffer overflow test */
-static void jffs2_decompression_test_prepare(unsigned char *buf, int size)
-{
-        memset(buf,JFFS2_BUFFER_FILL,size+1);
-}
-
-/* Called after compression (if compression_check is setted) to test the result */
-static void jffs2_decompression_test(struct jffs2_compressor *compr,
-                                     unsigned char *data_in, unsigned char *output_buf,
-                                     uint32_t cdatalen, uint32_t datalen, uint32_t buf_size)
-{
-        uint32_t i;
+#include "compr.h"
 
-        /* buffer overflow test */
-        for (i=buf_size;i>cdatalen;i--) {
-                if (output_buf[i]!=JFFS2_BUFFER_FILL) {
-                        fprintf(stderr,"COMPR_ERROR: buffer overflow at %s. "
-                                    "(bs=%d csize=%d b[%d]=%d)\n", compr->name,
-                                    buf_size, cdatalen, i, (int)(output_buf[i]));
-                        jffs2_error_cnt++;
-                        return;
-                }
-        }
-        /* allocing temporary buffer for decompression */
-        if (!jffs2_compression_check_buf) {
-                jffs2_compression_check_buf = malloc(page_size);
-                if (!jffs2_compression_check_buf) {
-                        fprintf(stderr,"No memory for buffer allocation. Compression check disabled.\n");
-                        jffs2_compression_check = 0;
-                        return;
-                }
-        }
-        /* decompressing */
-        if (!compr->decompress) {
-                fprintf(stderr,"JFFS2 compression check: there is no decompress function at %s.\n", compr->name);
-                jffs2_error_cnt++;
-                return;
-        }
-        if (compr->decompress(output_buf,jffs2_compression_check_buf,cdatalen,datalen,NULL)) {
-                fprintf(stderr,"JFFS2 compression check: decompression failed at %s.\n", compr->name);
-                jffs2_error_cnt++;
-        }
-        /* validate decompression */
-        else {
-                for (i=0;i<datalen;i++) {
-                        if (data_in[i]!=jffs2_compression_check_buf[i]) {
-                                fprintf(stderr,"JFFS2 compression check: data mismatch at %s (pos %d).\n", compr->name, i);
-                                jffs2_error_cnt++;
-                                break;
-                        }
-                }
-        }
-}
+static struct cryptolist_entry *crypto_compress_wrapper(struct compress_ctx *ctx,
+									char *alg_name, u8 *src, int32_t srclen,
+									u8 *dst, int32_t *dstlen)
+{
+	struct cryptolist_entry *ret = NULL;
+	int temp;
+	uint32_t alg_type;
+	struct cryptolist_entry *walk;
+	struct crypt_op cryp;
+	temp = strlen(alg_name);
+	if (*dstlen < (temp + 1))
+		goto out;
+	strcpy(dst, alg_name);
+	dst += temp;
+	*dst = '\0';
+	dst++;
+	(*dstlen) -= temp;
+	(*dstlen)--;
+	walk = ctx->cryptolist_head;
+	while (walk && strcmp(alg_name, walk->sess->alg_name))
+		walk = walk->next;
+	if (!walk) {
+		walk = malloc(sizeof(struct cryptolist_entry));
+		if (!walk)
+			goto out;
+
+		memset(walk, 0, sizeof(struct cryptolist_entry));
+		if (ioctl(ctx->global_fd, CRIOGET, &walk->c_fd)) {
+			free(walk);
+			goto out;
+		}
+		if (fcntl(walk->c_fd, F_SETFD, 1) == -1) {
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+
+		walk->sess = malloc(sizeof(struct session_op));
+		if (!walk->sess) {
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+		memset(walk->sess, 0, sizeof(struct session_op));
+		walk->sess->compress = CRYPTO_COMPRESS_NAME;
+
+		walk->sess->alg_name = malloc(temp + 1);
+		if (!walk->sess->alg_name) {
+			free(walk->sess);
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+		strcpy(walk->sess->alg_name, alg_name);
+		walk->sess->alg_namelen = temp;
+		if (ioctl(walk->c_fd, CIOCGSESSION, walk->sess)) {
+			free(walk->sess->alg_name);
+			free(walk->sess);
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+		if (!ctx->cryptolist_head)
+			ctx->cryptolist_head = walk;
+		else
+			ctx->cryptolist_tail->next = walk;
+		ctx->cryptolist_tail = walk;
+	}
+
+	alg_type = walk->sess->ses;
+	if (ioctl(walk->c_fd, CIOCGALGTYPE, &alg_type)) {
+		// error during ioctl
+		goto out;
+	}
+
+	switch (alg_type) {
+		case CRYPTO_ALG_TYPE_COMPRESS:
+			cryp.ses = walk->sess->ses;
+			cryp.len = srclen;
+			cryp.outlen = dstlen;
+			cryp.src = src;
+			cryp.dst = dst;
+			cryp.op = COP_COMPRESS;
+			if (ioctl(walk->c_fd, CIOCCOMPRESS, &cryp))
+				goto out;
+			(*dstlen) += temp;
+			(*dstlen)++;
+			ret = walk;
+			break;
+
+		default:
+			break;
+	}
 
-/* jffs2_compress:
- * @data: Pointer to uncompressed data
- * @cdata: Pointer to returned pointer to buffer for compressed data
- * @datalen: On entry, holds the amount of data available for compression.
- *	On exit, expected to hold the amount of data actually compressed.
- * @cdatalen: On entry, holds the amount of space available for compressed
- *	data. On exit, expected to hold the actual size of the compressed
- *	data.
- *
- * Returns: Lower byte to be stored with data indicating compression type used.
- * Zero is used to show that the data could not be compressed - the
- * compressed version was actually larger than the original.
- * Upper byte will be used later. (soon)
- *
- * If the cdata buffer isn't large enough to hold all the uncompressed data,
- * jffs2_compress should compress as much as will fit, and should set
- * *datalen accordingly to show the amount of data which were compressed.
- */
-uint16_t jffs2_compress( unsigned char *data_in, unsigned char **cpage_out,
-			 uint32_t *datalen, uint32_t *cdatalen)
-{
-	int ret = JFFS2_COMPR_NONE;
-        int compr_ret;
-        struct jffs2_compressor *this, *best=NULL;
-        unsigned char *output_buf = NULL, *tmp_buf;
-        uint32_t orig_slen, orig_dlen;
-        uint32_t best_slen=0, best_dlen=0;
-
-        switch (jffs2_compression_mode) {
-        case JFFS2_COMPR_MODE_NONE:
-                break;
-        case JFFS2_COMPR_MODE_PRIORITY:
-                orig_slen = *datalen;
-                orig_dlen = *cdatalen;
-                output_buf = malloc(orig_dlen+jffs2_compression_check);
-                if (!output_buf) {
-                        fprintf(stderr,"mkfs.jffs2: No memory for compressor allocation. Compression failed.\n");
-                        goto out;
-                }
-                list_for_each_entry(this, &jffs2_compressor_list, list) {
-                        /* Skip decompress-only backwards-compatibility and disabled modules */
-                        if ((!this->compress)||(this->disabled))
-                                continue;
-
-                        this->usecount++;
-
-                        if (jffs2_compression_check) /*preparing output buffer for testing buffer overflow */
-                                jffs2_decompression_test_prepare(output_buf, orig_dlen);
-
-                        *datalen  = orig_slen;
-                        *cdatalen = orig_dlen;
-                        compr_ret = this->compress(data_in, output_buf, datalen, cdatalen, NULL);
-                        this->usecount--;
-                        if (!compr_ret) {
-                                ret = this->compr;
-                                this->stat_compr_blocks++;
-                                this->stat_compr_orig_size += *datalen;
-                                this->stat_compr_new_size  += *cdatalen;
-                                if (jffs2_compression_check)
-                                        jffs2_decompression_test(this, data_in, output_buf, *cdatalen, *datalen, orig_dlen);
-                                break;
-                        }
-                }
-                if (ret == JFFS2_COMPR_NONE) free(output_buf);
-                break;
-        case JFFS2_COMPR_MODE_SIZE:
-                orig_slen = *datalen;
-                orig_dlen = *cdatalen;
-                list_for_each_entry(this, &jffs2_compressor_list, list) {
-                        /* Skip decompress-only backwards-compatibility and disabled modules */
-                        if ((!this->compress)||(this->disabled))
-                                continue;
-                        /* Allocating memory for output buffer if necessary */
-                        if ((this->compr_buf_size<orig_dlen+jffs2_compression_check)&&(this->compr_buf)) {
-                                free(this->compr_buf);
-                                this->compr_buf_size=0;
-                                this->compr_buf=NULL;
-                        }
-                        if (!this->compr_buf) {
-                                tmp_buf = malloc(orig_dlen+jffs2_compression_check);
-                                if (!tmp_buf) {
-                                        fprintf(stderr,"mkfs.jffs2: No memory for compressor allocation. (%d bytes)\n",orig_dlen);
-                                        continue;
-                                }
-                                else {
-                                        this->compr_buf = tmp_buf;
-                                        this->compr_buf_size = orig_dlen;
-                                }
-                        }
-                        this->usecount++;
-                        if (jffs2_compression_check) /*preparing output buffer for testing buffer overflow */
-                                jffs2_decompression_test_prepare(this->compr_buf,this->compr_buf_size);
-                        *datalen  = orig_slen;
-                        *cdatalen = orig_dlen;
-                        compr_ret = this->compress(data_in, this->compr_buf, datalen, cdatalen, NULL);
-                        this->usecount--;
-                        if (!compr_ret) {
-                                if (jffs2_compression_check)
-                                    jffs2_decompression_test(this, data_in, this->compr_buf, *cdatalen, *datalen, this->compr_buf_size);
-                                if ((!best_dlen)||(best_dlen>*cdatalen)) {
-                                        best_dlen = *cdatalen;
-                                        best_slen = *datalen;
-                                        best = this;
-                                }
-                        }
-                }
-                if (best_dlen) {
-                        *cdatalen = best_dlen;
-                        *datalen  = best_slen;
-                        output_buf = best->compr_buf;
-                        best->compr_buf = NULL;
-                        best->compr_buf_size = 0;
-                        best->stat_compr_blocks++;
-                        best->stat_compr_orig_size += best_slen;
-                        best->stat_compr_new_size  += best_dlen;
-                        ret = best->compr;
-                }
-                break;
-        default:
-                fprintf(stderr,"mkfs.jffs2: unknow compression mode.\n");
-        }
- out:
-        if (ret == JFFS2_COMPR_NONE) {
-	        *cpage_out = data_in;
-	        *datalen = *cdatalen;
-                none_stat_compr_blocks++;
-                none_stat_compr_size += *datalen;
-        }
-        else {
-                *cpage_out = output_buf;
-        }
+out:
 	return ret;
 }
 
-
-int jffs2_register_compressor(struct jffs2_compressor *comp)
-{
-        struct jffs2_compressor *this;
-
-        if (!comp->name) {
-                fprintf(stderr,"NULL compressor name at registering JFFS2 compressor. Failed.\n");
-                return -1;
-        }
-        comp->compr_buf_size=0;
-        comp->compr_buf=NULL;
-        comp->usecount=0;
-        comp->stat_compr_orig_size=0;
-        comp->stat_compr_new_size=0;
-        comp->stat_compr_blocks=0;
-        comp->stat_decompr_blocks=0;
-
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (this->priority < comp->priority) {
-                        list_add(&comp->list, this->list.prev);
-                        goto out;
-                }
-        }
-        list_add_tail(&comp->list, &jffs2_compressor_list);
+static struct cryptolist_entry *crypto_decompress_wrapper(struct compress_ctx *ctx,
+									u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen) {
+	struct cryptolist_entry *ret = NULL;
+	int temp = 0;
+	uint32_t alg_type;
+	struct cryptolist_entry *walk;
+	struct crypt_op cryp;
+	char *alg_name = (char *) src;
+	while (*src) {
+		src++;
+		srclen--;
+		temp++;
+	}
+	src++;
+	srclen--;
+	walk = ctx->cryptolist_head;
+	while (walk && strcmp(alg_name, walk->sess->alg_name))
+		walk = walk->next;
+	if (!walk) {
+		walk = malloc(sizeof(struct cryptolist_entry));
+		if (!walk)
+			goto out;
+		memset(walk, 0, sizeof(struct cryptolist_entry));
+		if (ioctl(ctx->global_fd, CRIOGET, &walk->c_fd)) {
+			free(walk);
+			goto out;
+		}
+		if (fcntl(walk->c_fd, F_SETFD, 1) == -1) {
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+
+		walk->sess = malloc(sizeof(struct session_op));
+		if (!walk->sess) {
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+
+		memset(walk->sess, 0, sizeof(struct session_op));
+		walk->sess->compress = CRYPTO_COMPRESS_NAME;
+
+		walk->sess->alg_name = malloc(temp + 1);
+		if (!walk->sess->alg_name) {
+			free(walk->sess);
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+
+		strcpy(walk->sess->alg_name, alg_name);
+		walk->sess->alg_namelen = temp;
+		if (ioctl(walk->c_fd, CIOCGSESSION, walk->sess)) {
+			free(walk->sess->alg_name);
+			free(walk->sess);
+			close(walk->c_fd);
+			free(walk);
+			goto out;
+		}
+		if (!ctx->cryptolist_head)
+			ctx->cryptolist_head = walk;
+		else
+			ctx->cryptolist_tail->next = walk;
+		ctx->cryptolist_tail = walk;
+	}
+	
+	alg_type = walk->sess->ses;
+	if (ioctl(walk->c_fd, CIOCGALGTYPE, &alg_type)) {
+		// error during ioctl
+		goto out;
+	}
+
+	switch (alg_type) {
+		case CRYPTO_ALG_TYPE_COMPRESS:
+			cryp.ses = walk->sess->ses;
+			cryp.len = srclen;
+			cryp.outlen = dstlen;
+			cryp.src = src;
+			cryp.dst = dst;
+			cryp.op = COP_DECOMPRESS;
+			if (!ioctl(walk->c_fd, CIOCCOMPRESS, &cryp))
+				ret = walk;
+			break;
+
+		default:
+			break;
+	}
 out:
-        return 0;
-}
-
-int jffs2_unregister_compressor(struct jffs2_compressor *comp)
-{
-
-        if (comp->usecount) {
-                fprintf(stderr,"mkfs.jffs2: Compressor modul is in use. Unregister failed.\n");
-                return -1;
-        }
-        list_del(&comp->list);
-
-        return 0;
-}
-
-#define JFFS2_STAT_BUF_SIZE 16000
-
-char *jffs2_list_compressors(void)
-{
-        struct jffs2_compressor *this;
-        char *buf, *act_buf;
-
-        act_buf = buf = malloc(JFFS2_STAT_BUF_SIZE);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                act_buf += sprintf(act_buf, "%10s priority:%d ", this->name, this->priority);
-                if ((this->disabled)||(!this->compress))
-                        act_buf += sprintf(act_buf,"disabled");
-                else
-                        act_buf += sprintf(act_buf,"enabled");
-                act_buf += sprintf(act_buf,"\n");
-        }
-        return buf;
-}
-
-char *jffs2_stats(void)
-{
-        struct jffs2_compressor *this;
-        char *buf, *act_buf;
-
-        act_buf = buf = malloc(JFFS2_STAT_BUF_SIZE);
-
-        act_buf += sprintf(act_buf,"Compression mode: ");
-        switch (jffs2_compression_mode) {
-        case JFFS2_COMPR_MODE_NONE:
-                act_buf += sprintf(act_buf,"none");
-                break;
-        case JFFS2_COMPR_MODE_PRIORITY:
-                act_buf += sprintf(act_buf,"priority");
-                break;
-        case JFFS2_COMPR_MODE_SIZE:
-                act_buf += sprintf(act_buf,"size");
-                break;
-        default:
-                act_buf += sprintf(act_buf,"unkown");
-                break;
-        }
-        act_buf += sprintf(act_buf,"\nCompressors:\n");
-        act_buf += sprintf(act_buf,"%10s             ","none");
-        act_buf += sprintf(act_buf,"compr: %d blocks (%d)  decompr: %d blocks\n", none_stat_compr_blocks,
-                           none_stat_compr_size, none_stat_decompr_blocks);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                act_buf += sprintf(act_buf,"%10s (prio:%d) ",this->name,this->priority);
-                if ((this->disabled)||(!this->compress))
-                        act_buf += sprintf(act_buf,"- ");
-                else
-                        act_buf += sprintf(act_buf,"+ ");
-                act_buf += sprintf(act_buf,"compr: %d blocks (%d/%d)  decompr: %d blocks ", this->stat_compr_blocks,
-                                   this->stat_compr_new_size, this->stat_compr_orig_size,
-                                   this->stat_decompr_blocks);
-                act_buf += sprintf(act_buf,"\n");
-        }
-        return buf;
-}
-
-int jffs2_set_compression_mode_name(const char *name)
-{
-        if (!strcmp("none",name)) {
-                jffs2_compression_mode = JFFS2_COMPR_MODE_NONE;
-                return 0;
-        }
-        if (!strcmp("priority",name)) {
-                jffs2_compression_mode = JFFS2_COMPR_MODE_PRIORITY;
-                return 0;
-        }
-        if (!strcmp("size",name)) {
-                jffs2_compression_mode = JFFS2_COMPR_MODE_SIZE;
-                return 0;
-        }
-        return 1;
-}
-
-static int jffs2_compressor_Xable(const char *name, int disabled)
-{
-        struct jffs2_compressor *this;
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (!strcmp(this->name, name)) {
-                        this->disabled = disabled;
-                        return 0;
-                }
-        }
-        return 1;
+	return ret;
 }
 
-int jffs2_enable_compressor_name(const char *name)
-{
-        return jffs2_compressor_Xable(name, 0);
+static void destroy_tree(struct compresstree_node *what) {
+	if (what->sib)
+		destroy_tree(what->sib);
+	if (what->fson)
+		destroy_tree(what->fson);
+	free(what->name);
+	free(what);
+}
+
+int destroy_compress_context(struct compress_ctx **ctx) {
+	int ret = 0;
+	if (*ctx) {
+		struct cryptolist_entry *temp;
+		destroy_tree((*ctx)->compresstree_root);
+		while ((temp = (*ctx)->cryptolist_head)) {
+			(*ctx)->cryptolist_head = (*ctx)->cryptolist_head->next;
+			if (ioctl(temp->c_fd, CIOCFSESSION, temp->sess->ses)) {
+				ret = -1;
+				goto out;
+			}
+			free(temp->sess->alg_name);
+			free(temp->sess);
+			close(temp->c_fd);
+			free(temp);
+		}
+		close((*ctx)->global_fd);
+		free(*ctx);
+		*ctx = NULL;
+	}
+out:
+	return ret;
 }
 
-int jffs2_disable_compressor_name(const char *name)
-{
-        return jffs2_compressor_Xable(name, 1);
+struct compress_ctx *create_compress_context(char *cnt) {
+	char *w, *w2, *scan, *c, *ccnt, end;
+	compressmode_t node_type = COMPRESSMODE_NORMAL;
+	int breakout, temp;	
+	struct compresstree_node *nodetemp, *nodewalk;
+	struct compresstree_tail *tail, *tailtemp, *tailend;
+	struct compress_ctx *ret;
+
+	ret = malloc(sizeof(struct compress_ctx));
+	if (!ret)
+		goto out;
+	ret->cryptolist_head = ret->cryptolist_tail = NULL;
+	ret->compresstree_root = NULL;
+	if ((ret->global_fd = open("/dev/crypto", O_RDWR, 0)) < 0)
+		goto was_error;
+	while (*cnt && ((*cnt == ',') || (*cnt == ' ') || (*cnt == '\t')))
+		cnt++;
+	temp = strlen(cnt);
+	if (!(ccnt = (char *) malloc(temp + 1)))
+		goto was_error;
+	strcpy(ccnt, cnt);
+	while (temp && ((ccnt[temp - 1] == ',') || (ccnt[temp - 1] == ' ') || (ccnt[temp - 1] == '\t'))) {
+		ccnt[temp] = '\0';
+		temp--;
+	}
+	if (!temp) {
+		free(ccnt);
+		goto out; /* compression will be turned off */
+	}
+
+	tail = malloc(sizeof(struct compresstree_tail));
+	tailend = tail;
+	if (!tailend) {
+		free(ccnt);
+		goto was_error;
+	}
+
+	tail->owner = NULL;
+	tail->next = NULL;
+	tail->tail = ccnt;
+	while (tail) {
+		w2 = w = tail->tail;
+		scan = NULL;
+		breakout = 0;
+		while (!breakout) {
+			switch (*w) {
+				case '{':
+				case '[':
+					if (node_type != COMPRESSMODE_NORMAL)
+						goto was_error_clean;
+					if (*w == '{') {
+						node_type = COMPRESSMODE_BESTCOMPRESS;
+						end = '}';
+					} else
+					if (*w == '[') {
+						node_type = COMPRESSMODE_FIRSTCOMPRESS;
+						end = ']';
+					} else
+						end = '\0';
+					w++;
+					while (*w && ((*w == ',') || (*w == '\t') || (*w == ' ')))
+						w++;
+					w2 = w;
+					scan = w;
+					while (*scan && (*scan != end)) scan++;
+					if (*scan) scan++;
+					while (*scan && ((*scan == ',') || (*scan == '\t') || (*scan == ' ')))
+						scan++;
+					break;
+				case '\0':
+				case ' ':
+				case '\t':
+				case ',':
+				case '}':
+				case ']':
+					if ((*w == '}') && (node_type != COMPRESSMODE_BESTCOMPRESS))
+						goto was_error_clean;
+					if ((*w == ']') && (node_type != COMPRESSMODE_FIRSTCOMPRESS))
+						goto was_error_clean;
+					if (w2 != w) { /* to skip empty {} and [] */
+						if (!(c = (char *) malloc(w - w2 + 1)))
+							goto was_error_clean;
+						strncpy(c, w2, w - w2);
+						c[w - w2] = '\0';
+
+						nodetemp = malloc(sizeof(struct compresstree_node));
+						if (!nodetemp) {
+							free(c);
+							goto was_error_clean;
+						}
+
+						nodetemp->dad = tail->owner;
+						nodetemp->sib = nodetemp->fson = NULL;
+						nodetemp->name = c;
+						nodetemp->node_type = node_type;
+						if (tail->owner) {
+							if (!tail->owner->fson)
+								tail->owner->fson = nodetemp;
+							else {
+								nodewalk = tail->owner->fson;
+								while (nodewalk->sib)
+									nodewalk = nodewalk->sib;
+								nodewalk->sib = nodetemp;
+							}
+						} else
+							if (!ret->compresstree_root)
+								ret->compresstree_root = nodetemp;
+							else {
+								nodewalk = ret->compresstree_root;
+								while (nodewalk->sib)
+									nodewalk = nodewalk->sib;
+								nodewalk->sib = nodetemp;
+							}
+						if (scan && *scan) {
+							tailtemp = malloc(sizeof(struct compresstree_tail));
+							if (!tailtemp)
+								goto was_error_clean;
+							tailtemp->owner = nodetemp;
+							tailtemp->next = NULL;
+
+							tailtemp->tail = malloc(strlen(scan) + 1);
+							if (!tailtemp->tail)
+								goto was_error_clean;
+							strcpy(tailtemp->tail, scan);
+							tailend->next = tailtemp;
+							tailend = tailtemp;
+						}
+						if ((*w == '}') || (*w == ']'))
+							node_type = COMPRESSMODE_NORMAL;
+						if (tail && ((node_type == COMPRESSMODE_NORMAL) || !*w)) {
+							scan = NULL;
+							tailtemp = tail;
+							tail = tail->next;
+							free(tailtemp->tail);
+							free(tailtemp);
+							breakout = 1;
+							break;
+						}
+					} else
+						node_type = COMPRESSMODE_NORMAL;
+					if (*w)
+						w++;
+					while (*w && ((*w == ',') || (*w == '\t') || (*w == ' ')))
+						w++;
+					w2 = w;
+					break;
+				default:
+					w++;
+					if (!scan) {
+						scan = w;
+						while (*scan && (*scan != ',') && (*scan != '\t') && (*scan != ' '))
+							scan++;
+						while (*scan && ((*scan == ',') || (*scan == '\t') || (*scan == ' ')))
+							scan++;
+					}
+			}
+		}
+	}
+	goto out;
+was_error_clean:
+	destroy_tree(ret->compresstree_root);
+	while (tail) {
+		tailtemp = tail;
+		tail = tail->next;
+		free(tailtemp->tail);
+		free(tailtemp);
+	}
+was_error:
+	close(ret->global_fd);
+	free(ret);
+	ret = NULL;
+out:
+	return ret;
 }
 
-int jffs2_set_compressor_priority(const char *name, int priority)
-{
-        struct jffs2_compressor *this,*comp;
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (!strcmp(this->name, name)) {
-                        this->priority = priority;
-                        comp = this;
-                        goto reinsert;
-                }
-        }
-        fprintf(stderr,"mkfs.jffs2: compressor %s not found.\n",name);
-        return 1;
-reinsert:
-        /* list is sorted in the order of priority, so if
-           we change it we have to reinsert it into the
-           good place */
-        list_del(&comp->list);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (this->priority < comp->priority) {
-                        list_add(&comp->list, this->list.prev);
-                        return 0;
-                }
-        }
-        list_add_tail(&comp->list, &jffs2_compressor_list);
-        return 0;
+int compress(struct compress_ctx **ctx, u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen) {
+	int ret = 0;
+	int32_t selectedlen = srclen;
+	u8 *selected;
+	struct compresstree_node *selwalk;
+	struct cryptolist_entry *currc, *selc = NULL;
+	if (!*ctx)
+		goto out;
+
+	selected = malloc(selectedlen);
+	if (!selected) {
+		ret = -1;
+		goto out;
+	}
+
+	memcpy(selected, src, selectedlen);
+	selwalk = (*ctx)->compresstree_root;
+	while (selwalk) {
+		u8 *best = NULL;
+		struct compresstree_node *walk = selwalk;
+		int32_t bestlen = 0;
+		while (walk) {
+			u8 *curr;
+			int32_t currlen = *dstlen;
+
+			curr = malloc(currlen);
+			if (!curr) {
+				free(selected);
+				ret = -1;
+				goto out;
+			}
+			if ((currc = crypto_compress_wrapper(*ctx, walk->name, selected, selectedlen, curr, &currlen)) &&
+				(!bestlen || ((walk->node_type == COMPRESSMODE_BESTCOMPRESS) && (currlen < bestlen)))) {
+					if (bestlen)
+						free(best);
+					bestlen = currlen;
+					best = curr;
+					selwalk = walk;
+					selc = currc;
+			} else
+				free(curr);
+//			if (walk->node_type != COMPRESSMODE_BESTCOMPRESS)
+			if (walk->node_type == COMPRESSMODE_NORMAL || (walk->node_type == COMPRESSMODE_FIRSTCOMPRESS && currc))
+				break;
+			walk = walk->sib;
+		}
+		if (!bestlen || /*(selectedlen < bestlen)*/
+						(*dstlen < bestlen))
+			break;
+		free(selected);
+		selected = best;
+		selc->tot_to_compress += selectedlen;
+		selc->tot_compressed += bestlen;
+		selc->compr_blocks++;
+		selectedlen = bestlen;
+		selwalk = selwalk->fson;
+		/* contains the number of compressors compressed with so far */
+		ret++;
+	}
+	/* just return error if could not compress. app should take care of this */
+	if (ret && (selectedlen <= *dstlen))
+		memcpy(dst, selected, *dstlen = selectedlen);
+	else
+		ret = -1;
+	free(selected);
+out:
+	return ret;
 }
 
-
-int jffs2_compressors_init(void)
-{
-#ifdef CONFIG_JFFS2_ZLIB
-        jffs2_zlib_init();
-#endif
-#ifdef CONFIG_JFFS2_RTIME
-        jffs2_rtime_init();
-#endif
-        return 0;
+int decompress(struct compress_ctx **ctx, u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen, int compressors) {
+	int tmplen = srclen;
+	int ret = 0;
+	struct cryptolist_entry *currc;
+	u8 *tmp;
+	if (!*ctx)
+		goto out;
+
+	tmp = malloc(tmplen);
+	if (!tmp) {
+		ret = -1;
+		goto out;
+	}
+
+	memcpy(tmp, src, tmplen);
+	while (compressors) {
+		u8 *tmp2 = tmp;
+		int slen = tmplen;
+
+		tmplen = *dstlen;
+		tmp = malloc(tmplen);
+		if (!tmp) {
+			ret = -1;
+			goto out;
+		}
+
+		currc = crypto_decompress_wrapper(*ctx, tmp2, slen, tmp, &tmplen);
+		if (!currc) {
+			free(tmp);
+			free(tmp2);
+			ret = -1;
+			goto out;
+		} else {
+			currc->tot_to_decompress += slen;
+			currc->tot_decompressed += tmplen;
+			currc->decompr_blocks++;
+		}
+		free(tmp2);
+		compressors--;
+	}
+	memcpy(dst, tmp, *dstlen = tmplen);
+	free(tmp);
+out:
+	return ret;
 }
 
-int jffs2_compressors_exit(void)
-{
-#ifdef CONFIG_JFFS2_RTIME
-        jffs2_rtime_exit();
-#endif
-#ifdef CONFIG_JFFS2_ZLIB
-        jffs2_zlib_exit();
-#endif
-        return 0;
+char *compress_stats(struct compress_ctx **ctx) {
+	struct cryptolist_entry *temp;
+	char *buf = NULL, *act_buf;
+	if (*ctx) {
+		buf = malloc(JFFS2_STAT_BUF_SIZE);
+		act_buf = buf;
+		if (act_buf) {
+			act_buf += sprintf(act_buf, "Compressors:\n");
+			temp = (*ctx)->cryptolist_head;
+			while (temp) {
+				act_buf += sprintf(act_buf, "%10s compressed: %llu -> %llu, %llu blocks; decompressed: %llu -> %llu, %llu blocks\n",
+				temp->sess->alg_name, temp->tot_to_compress, temp->tot_compressed, temp->compr_blocks,
+				temp->tot_to_decompress, temp->tot_decompressed, temp->decompr_blocks);
+				temp = temp->next;
+			}
+		}
+	}
+	return buf;
 }
